<template>
  <SwPluginSlot name="gs-navigation-list">
    <ul v-if="(isGuide || isSelfService) && navigation && isPageListOpen" class="sw-gs-navigation-list-wrapper">
      <li v-for="(page, index) in navigation" :key="page.name + index">
        <a v-if="page.items.length === 1"
           class="sw-gs-navigation-list-link-main"
           :class="{'is-active': page.items[0].index === currentSlideIndex}"
           @click="navigate(page.items[0].index)">
          {{ page.name }}
        </a>
        <template v-else>
          {{ page.name }}
        </template>

        <ul v-if="page.items.length > 1" class="sw-gs-navigation-list">
          <li v-for="slide in page.items" :key="slide.id">
            <a class="sw-gs-navigation-list-link"
               :class="{'is-active': slide.index === currentSlideIndex}"
               @click="navigate(slide.index)">
              <template v-if="slide.sectionName">
                {{ slide.sectionName }}
              </template>
              <template v-else>
                {{ $t('Slide') }} {{ slide.index }}
              </template>
            </a>
          </li>
        </ul>
      </li>
    </ul>
  </SwPluginSlot>
</template>

<script lang="ts">
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
  import { SwGsIconBars } from "../icons";
  import { useAppointment } from "../../logic/composables/useAppointment";
  import { usePresentation } from "../../logic/composables/usePresentation";
  import { useInstantListing } from "../../logic/composables/useInstantListing";
  import { useUIState } from "@shopware-pwa/composables";

  export default {
    name: 'SwGsNavigationList',
    components: {
      SwPluginSlot,
      SwGsIconBars
    },
    setup() {
      const { isGuide, isSelfService } = useAppointment();
      const { currentSlideIndex, goToSlide, treeNavigation } = usePresentation();
      const { isOpen: isPageListOpen, switchState: togglePageList } = useUIState({ stateName: "GS_NAVIGATION_PAGE_LIST_STATE" });
      const { closeInstantListing } = useInstantListing();

      const navigate = (index: number) => {
        closeInstantListing();
        togglePageList(false);
        goToSlide(index);
      };

      return {
        isGuide,
        isSelfService,
        navigation: treeNavigation,
        togglePageList,
        isPageListOpen,
        currentSlideIndex,
        navigate
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-navigation-list-wrapper {
    padding: 0;
    margin: var(--spacer-sm) 0 0 0;

    &, ul {
      list-style: none;
    }
  }

  .sw-gs-navigation-list {
    padding: 0;
    font-size: var(--font-size--sm);
  }

  .sw-gs-navigation-list-link-main,
  .sw-gs-navigation-list-link {
    cursor: pointer;
    display: block;

    &:hover {
      color: var(--c-primary);
    }

    &.is-active {
      font-weight: var(--font-weight--bold);
    }
  }

  .sw-gs-navigation-list-link {
    padding-left: var(--spacer-base);
    padding-bottom: var(--spacer-xs);
  }
</style>
